//+------------------------------------------------------------------+
//|                                               Exp_3Parabolic.mq5 |
//|                             Copyright  2011,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"
//+----------------------------------------------+
//|            |
//+----------------------------------------------+
input double MM=-0.1;             //      ,   -  
input int    StopLoss_=1000;      //  
input int    TakeProfit_=2000;    //  
input int    Deviation_=10;       //.    
input bool   BuyPosOpen=true;     //    
input bool   SellPosOpen=true;    //    
input bool   BuyPosClose=true;     //    
input bool   SellPosClose=true;    //    
//+----------------------------------------------+
//|    3Parabolic      |
//+----------------------------------------------+
input ENUM_TIMEFRAMES TimeFrame1=PERIOD_H6;  //1    
input ENUM_TIMEFRAMES TimeFrame2=PERIOD_H3;  //2    
input ENUM_TIMEFRAMES TimeFrame3=PERIOD_H1;  //3    
input double SarStep=0.02;    //
input double SarMaximum=0.2;  //
input uint SignalBar=1;    //     
//+----------------------------------------------+

int TimeShiftSec;
//----      
int InpInd_Handle_1,InpInd_Handle_2,InpInd_Handle_3;
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//                                                  | 
//+------------------------------------------------------------------+
#include <TradeAlgorithms.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//----    iSAR
   InpInd_Handle_1=iSAR(NULL,TimeFrame1,SarStep,SarMaximum);
   if(InpInd_Handle_1==INVALID_HANDLE) Print("      iSAR 1");

//----    iSAR
   InpInd_Handle_2=iSAR(NULL,TimeFrame2,SarStep,SarMaximum);
   if(InpInd_Handle_2==INVALID_HANDLE) Print("      iSAR 2");

//----    iSAR
   InpInd_Handle_3=iSAR(NULL,TimeFrame3,SarStep,SarMaximum);
   if(InpInd_Handle_3==INVALID_HANDLE) Print("      iSAR 3");

//----          
   TimeShiftSec=PeriodSeconds(TimeFrame3);

//----     
   min_rates_total=int(2+SignalBar);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//----
   GlobalVariableDel_(Symbol());
//----
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//----       
   if(BarsCalculated(InpInd_Handle_1)<min_rates_total
      || BarsCalculated(InpInd_Handle_2)<min_rates_total
      || BarsCalculated(InpInd_Handle_3)<min_rates_total) return;

//----       IsNewBar()  SeriesInfoInteger()  
   LoadHistory(TimeCurrent()-PeriodSeconds(TimeFrame1)-1,Symbol(),TimeFrame1);
   LoadHistory(TimeCurrent()-PeriodSeconds(TimeFrame2)-1,Symbol(),TimeFrame2);
   LoadHistory(TimeCurrent()-PeriodSeconds(TimeFrame3)-1,Symbol(),TimeFrame3);

//----   
   double Sar_3[2],Close_3[2];
   static double Sar_1[1],Sar_2[1];
   static double Close_1[1],Close_2[1];
//----   
   static bool Recount=true;
   static bool BUY_Open=false,BUY_Close=false;
   static bool SELL_Open=false,SELL_Close=false;
   static datetime UpSignalTime,DnSignalTime;
   static CIsNewBar NB1,NB2,NB3;

//----      
   if(!SignalBar || NB1.IsNewBar(Symbol(),TimeFrame1) || Recount) //     
     {
      Recount=false;
      if(CopyBuffer(InpInd_Handle_1,0,SignalBar,1,Sar_1)<=0) {Recount=true; return;}
      if(CopyClose(Symbol(),TimeFrame1,SignalBar,1,Close_1)<=0) {Recount=true; return;}
      
      if(SellPosClose) if(Sar_1[0]<Close_1[0]) SELL_Close=true;
      if(BuyPosClose) if(Sar_1[0]>Close_1[0]) BUY_Close=true;
     }
     
//----      
   if(!SignalBar || NB2.IsNewBar(Symbol(),TimeFrame2) || Recount) //     
     {
      Recount=false;
      if(CopyBuffer(InpInd_Handle_2,0,SignalBar,1,Sar_2)<=0) {Recount=true; return;}
      if(CopyClose(Symbol(),TimeFrame2,SignalBar,1,Close_2)<=0) {Recount=true; return;}
      
      if(SellPosClose) if(Sar_2[0]<Close_2[0]) SELL_Close=true;
      if(BuyPosClose) if(Sar_2[0]>Close_2[0]) BUY_Close=true;
     }

//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
   if(!SignalBar || NB3.IsNewBar(Symbol(),TimeFrame3) || Recount) //     
     {
      //----   
      BUY_Open=false;
      SELL_Open=false;
      BUY_Close=false;
      SELL_Close=false;
      Recount=false;

      //----            
      if(CopyBuffer(InpInd_Handle_3,0,SignalBar,2,Sar_3)<=0) {Recount=true; return;}      
      if(CopyClose(Symbol(),TimeFrame3,SignalBar,2,Close_3)<=0) {Recount=true; return;}     

      if(SellPosClose) if(Sar_3[1]<Close_3[1]) SELL_Close=true;
      if(BuyPosClose) if(Sar_3[1]>Close_3[1]) BUY_Close=true;

      //----    
      if(Sar_1[0]<Close_1[0] && Sar_2[0]<Close_2[0] && Sar_3[0]>Close_3[0] && Sar_3[1]<Close_3[1])
        {
         if(BuyPosOpen) BUY_Open=true;
         UpSignalTime=datetime(SeriesInfoInteger(Symbol(),TimeFrame3,SERIES_LASTBAR_DATE))+TimeShiftSec;
        }

      //----    
      if(Sar_1[0]>Close_1[0] && Sar_2[0]>Close_2[0] && Sar_3[0]<Close_3[0] && Sar_3[1]>Close_3[1])
        {
         if(SellPosOpen) SELL_Open=true;
         UpSignalTime=datetime(SeriesInfoInteger(Symbol(),TimeFrame3,SERIES_LASTBAR_DATE))+TimeShiftSec;
        }
     }

//+----------------------------------------------+
//|                              |
//+----------------------------------------------+
//----  
   BuyPositionClose(BUY_Close,Symbol(),Deviation_);

//----     
   SellPositionClose(SELL_Close,Symbol(),Deviation_);

//----  
   BuyPositionOpen(BUY_Open,Symbol(),UpSignalTime,MM,0,Deviation_,StopLoss_,TakeProfit_);

//----  
   SellPositionOpen(SELL_Open,Symbol(),DnSignalTime,MM,0,Deviation_,StopLoss_,TakeProfit_);
//----
  }
//+------------------------------------------------------------------+
